# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/pinctrl/amlogic,meson-pinctrl-a1.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Amlogic Meson A1 pinmux controller

maintainers:
  - Neil Armstrong <neil.armstrong@linaro.org>

allOf:
  - $ref: amlogic,meson-pinctrl-common.yaml#

properties:
  compatible:
    enum:
      - amlogic,c3-periphs-pinctrl
      - amlogic,meson-a1-periphs-pinctrl
      - amlogic,meson-s4-periphs-pinctrl

required:
  - compatible

patternProperties:
  "^bank@[0-9a-z]+$":
    $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-gpio

    unevaluatedProperties: false

    properties:
      reg:
        maxItems: 2

      reg-names:
        items:
          - const: mux
          - const: gpio

      gpio-line-names:
        minItems: 62 # A1
        maxItems: 82 # S4

unevaluatedProperties:
  type: object
  $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-pins

examples:
  - |
    periphs_pinctrl: pinctrl {
      compatible = "amlogic,meson-a1-periphs-pinctrl";
      #address-cells = <1>;
      #size-cells = <1>;
      ranges;

      bank@400 {
        reg = <0x0400 0x003c>,
              <0x0480 0x0118>;
        reg-names = "mux", "gpio";
        gpio-controller;
        #gpio-cells = <2>;
        gpio-ranges = <&periphs_pinctrl 0 0 62>;
      };

      cec_ao_a_h_pins: cec_ao_a_h {
        mux {
          groups = "cec_ao_a_h";
          function = "cec_ao_a_h";
          bias-disable;
        };
      };
    };
